unit ParentMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    CreateAThread1: TMenuItem;
    LaunchChildApp1: TMenuItem;
    procedure CreateAThread1Click(Sender: TObject);
    procedure LaunchChildApp1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  EWin32Error = class(Exception);

var
  Form1: TForm1;

implementation

uses
  ParentSemaphoreUnit;

{$R *.DFM}

procedure TForm1.CreateAThread1Click(Sender: TObject);
begin
  with TTestParentSemaphore.Create do
    FreeOnTerminate := True
end;

procedure TForm1.LaunchChildApp1Click(Sender: TObject);
const
  ChildApp = 'ChildSemaphore.Exe';
var
  SI: TStartupInfo;
  PI: TProcessInformation;
begin
  GetStartupInfo(SI);
  if not CreateProcess(nil, ChildApp, nil,
           nil, False, 0, nil, nil, SI, PI) then
    raise EWin32Error.Create('Unable to launch ' + ChildApp);
end;

end.
