unit Example_TLB;

{ This file contains pascal declarations imported from a type library.
  This file will be written during each import or refresh of the type
  library editor.  Changes to this file will be discarded during the
  refresh process. }

{ Example Library }
{ Version 1.0 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_Example: TGUID = '{B6D0DB20-C007-11D1-96E6-444553540000}';

const

{ Component class GUIDs }
  Class_Server: TGUID = '{B6D0DB22-C007-11D1-96E6-444553540000}';

type

{ Forward declarations: Interfaces }
  IServer = interface;
  IServerDisp = dispinterface;

{ Forward declarations: CoClasses }
  Server = IServer;

{ Dispatch interface for Server Object }

  IServer = interface(IDispatch)
    ['{B6D0DB21-C007-11D1-96E6-444553540000}']
    function Get_CurrentDateAndTime: TDateTime; safecall;
    property CurrentDateAndTime: TDateTime read Get_CurrentDateAndTime;
  end;

{ DispInterface declaration for Dual Interface IServer }

  IServerDisp = dispinterface
    ['{B6D0DB21-C007-11D1-96E6-444553540000}']
    property CurrentDateAndTime: TDateTime readonly dispid 1;
  end;

{ ServerObject }

  CoServer = class
    class function Create: IServer;
    class function CreateRemote(const MachineName: string): IServer;
  end;



implementation

uses ComObj;

class function CoServer.Create: IServer;
begin
  Result := CreateComObject(Class_Server) as IServer;
end;

class function CoServer.CreateRemote(const MachineName: string): IServer;
begin
  Result := CreateRemoteComObject(MachineName, Class_Server) as IServer;
end;


end.
