unit ChildU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    procedure GetPostedAppMessages(var Msg: TMsg; var Handled: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GetPostedAppMessages(var Msg: TMsg; var Handled: Boolean);
begin
  with Msg do
    if HWnd = 0 then { check if it's one of ours } 
    begin
      PostMessage(Application.Handle, Message, WParam, LParam);
      Handled := True;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnMessage := GetPostedAppMessages
end;

end.
